// import axios from 'axios'
import { isArray } from 'lodash'
// import { API_URL } from '../constants/ResourceNames'
import http from '../utils/http'
import { 
    REQUEST_START,
    REQUEST_OK, 
    REQUEST_KO, 
    SHOW_SPINNER, 
    HIDE_SPINNER, 
    SHOW_NOTIFICATION, 
    HIDE_NOTIFICATION 
} from '../constants/ActionTypes'

/**
 * 
 * @param {*} message 
 */
export const spinner = (show, message) => dispatch => {
    dispatch({
        type: show ? SHOW_SPINNER : HIDE_SPINNER,
        payload: message
    })
}

/**
 * 
 * @param {*} text 
 */
export const notify = message => dispatch  => {
    dispatch({
        type: message ? SHOW_NOTIFICATION : HIDE_NOTIFICATION,
        payload: message
    })
}

/**
 * 
 */
export const checkLogin = () => dispatch => {
    console.log('e')
}

/**
 * 
 * @param {*} resource 
 */
export const get = resource => async dispatch => {
    dispatch({
        type: REQUEST_START
    })

    try {
        // const response = await axios.get(`${API_URL}${resource}`)
        const response = await http.get(`${resource}`)
        dispatch(ok(response.data))
    } catch (error) {
        dispatch(ko(resource, error.response))
    }
}

/**
 * 
 * @param {*} resource 
 */
export const post = (resources, data) => async dispatch => {
    dispatch({
        type: REQUEST_START
    })
    
    data = data || {}


    if (isArray(resources)) {
        for (let r of resources) {
            try {
                // const response = await axios.post(`${API_URL}${r}`, data)
                const response = await http.post(`${r}`, data)
                dispatch(ok(response.data))
            } catch (error) {
                dispatch(ko(r, error))
            }
        }
    } else {
        try {
            // const response = await axios.post(`${API_URL}${resources}`, data)
            const response = await http.post(`${resources}`, data)
            dispatch(ok(response.data))
        } catch (error) {
            dispatch(ko(resources, error))
        }
    }
}

/**
 * 
 * @param {*} resource 
 * @param {*} payload 
 */
const ok = payload => {
    return {
        type: REQUEST_OK,
        payload
    }
}

/**
 * 
 * @param {*} resource 
 * @param {*} payload 
 */
const ko = (resource, payload) => {
    return {
        type: REQUEST_KO,
        resource,
        payload
    }
}
