import React, { Component } from 'react'
import { MuiThemeProvider, createMuiTheme } from 'material-ui/styles'
import CssBaseline from 'material-ui/CssBaseline'
import { Provider } from 'react-redux'
import { ConnectedRouter } from 'react-router-redux'
import { store, history } from '../reducers'
import Routes from '../components/common/Routes'

class App extends Component {
    /**
     * 
     * @param {*} error 
     * @param {*} info 
     */
    componentDidCatch(error, info) {
        console.log(error, info)
    }

    /**
     * 
     */
    render() {
        const theme = createMuiTheme({
            palette: {
                primary: { 
                    main: '#0288d1'
                }
            },
            typography: {
                fontSize: 12
            }
        })

        return (
            <MuiThemeProvider theme={theme}>    
                <CssBaseline />
                <Provider store={store}>
                    <ConnectedRouter history={history}>
                        <Routes />
                    </ConnectedRouter>
                </Provider>
            </MuiThemeProvider>
        )
    }
}

export default App