import React, { Component } from 'react'
import { connect } from 'react-redux'
import { Route, Redirect, withRouter } from 'react-router-dom'
import Login from '../pages/Login'
import routes from '../../routes'

class Routes extends Component {
    render() {
        const { isAuthenticated } = this.props

        return (
            <div>
                {routes.map((route, index) =>
                    <Route 
                        key={index} 
                        path={route.path} 
                        render={props => isAuthenticated ? (
                                <route.component title={route.title} />
                            ) : (
                                <Redirect to={{
                                    pathname: '/login', 
                                    state: { 
                                        from: props.location 
                                    }
                                }} 
                            />)
                        } 
                    />
                )}
                <Route path='/login' component={Login} />
            </div>
        )
    }
}

/**
 * 
 * @param {*} state 
 * @param {*} props 
 */
const mapStateToProps = (state, props) => {
    return {
        isAuthenticated: state.app.isAuthenticated
    }
}


export default withRouter(connect(mapStateToProps)(Routes))