import React, { Component } from 'react'
import Drawer from 'material-ui/Drawer'
import ListSubheader from 'material-ui/List/ListSubheader'
import List, { ListItem, ListItemIcon, ListItemText } from 'material-ui/List'
import { Link } from 'react-router-dom'
import FactoryIcon from '../icons/FactoryIcon'
import TaskIcon from '../icons/TaskIcon'
import DockerIcon from '../icons/DockerIcon'
import UserIcon from '../icons/UserIcon'
import PermissionIcon from '../icons/PermissionIcon'
import AboutIcon from '../icons/AboutIcon'
import { withStyles } from 'material-ui/styles'


const drawerWidth = 265

const styles = theme => ({
    root: {
        position: 'relative',
        width: drawerWidth
    },
    toolbar: theme.mixins.toolbar
})

class Sidebar extends Component {
    render() {
        const { classes } = this.props

        return (
            <Drawer variant="permanent" classes={{paper: classes.root}}>
                <div className={classes.toolbar} />
                <List component="nav">
                    <ListSubheader>Sistemas</ListSubheader>
                    <ListItem button component={Link} to='/containers'>
                        <ListItemIcon>
                            <DockerIcon />
                        </ListItemIcon>
                        <ListItemText primary="Contenedores" />
                    </ListItem>
                    <ListItem button component={Link} to='/tasks'>
                        <ListItemIcon>
                            <FactoryIcon />
                        </ListItemIcon>
                        <ListItemText primary="Tareas automatizadas" />
                    </ListItem>
                    <ListItem button component={Link} to='/requests'>
                        <ListItemIcon>
                            <TaskIcon />
                        </ListItemIcon>
                        <ListItemText primary="Solicitudes" />
                    </ListItem>
                    <ListSubheader>Administración</ListSubheader>
                    <ListItem button component={Link} to='/users'>
                        <ListItemIcon>
                            <UserIcon />
                        </ListItemIcon>
                        <ListItemText primary="Usuarios" />
                    </ListItem>
                    <ListItem button component={Link} to='/permissions'>
                        <ListItemIcon>
                            <PermissionIcon />
                        </ListItemIcon>
                        <ListItemText primary="Permisos" />
                    </ListItem>
                    <ListSubheader>Ayuda</ListSubheader>
                    <ListItem button component={Link} to='/about'>
                        <ListItemIcon>
                            <AboutIcon />
                        </ListItemIcon>
                        <ListItemText primary="Acerca" />
                    </ListItem>
                </List>
            </Drawer>
        )
    }
}

export default withStyles(styles)(Sidebar)

