import React, { Component } from 'react'
import { CircularProgress } from 'material-ui/Progress'
import Typography from 'material-ui/Typography'
import { withStyles } from 'material-ui/styles'

const styles = theme => ({
    root: {
        justifyContent: 'center',
        alignItems: 'center',
        flexDirection: 'column',
        position: 'absolute',
        width: '100%',
        height: '100%',
        background: '#fff',
        opacity: 0.7,
        zIndex: 9999,
        userSelect: 'none'
    },
    spinnerText: {
        marginTop: '1.735em'
    }
})

class Spinner extends Component {
    
    /**
     * 
     */
    render() {
        const { classes } = this.props

        return (
            <div className={classes.root} style={this.props.open ? {display: 'flex'} : {display: 'none'}}>
                <CircularProgress />
                <Typography 
                    variant='subheading' 
                    color='primary' 
                    className={classes.spinnerText} 
                    children={this.props.message} 
                />
            </div>
        )
    }
}

export default withStyles(styles)(Spinner)