import { REQUEST_OK } from '../constants/ActionTypes'
import { has, map, isEqual } from 'lodash'

/**
 * 
 * @param {*} state 
 * @param {*} action 
 */
export const containers = (state = [], action) => {
    if (action.type !== REQUEST_OK) {
        return state
    }

    if (has(action.payload, 'container')) {
        return map(state, c => {
            return isEqual(c.id, action.payload.container.id) ? action.payload.container : c
        })
    }

    if (has(action.payload, 'containers')) {
        return action.payload.containers
    }

    return state
}