import { createStore, combineReducers, applyMiddleware } from 'redux'
import { routerReducer, routerMiddleware } from 'react-router-redux'
import createBrowserHistory from 'history/createBrowserHistory'
import ThunkMiddleware from  'redux-thunk'
import LoggerMiddleware from 'redux-logger'

import { app } from './app'
import { containers } from './containers'
import { requests } from './requests'

const history = createBrowserHistory()

const rootReducer = combineReducers({
    app,
    containers,
    requests,
    router: routerReducer
})

const RouterMiddleware = routerMiddleware(history)

const store = createStore(rootReducer, applyMiddleware(RouterMiddleware, ThunkMiddleware, LoggerMiddleware))

export {
    history,
    store
}