import axios from 'axios'
import { API_URL } from '../constants/ResourceNames'

const TOKEN_KEY = 'eiruAutomation'

// Create instance
const instance = axios.create({
    baseURL: API_URL,
    headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
    },
    timeout: 1000
})

// Define interceptor
instance.interceptors.request.use(config => {
    const token = localStorage.getItem(TOKEN_KEY)

    if (token) {
        config.headers['Authorization'] = `JWT ${token}`
    }

    return config
}, error => Promise.reject(error))

// Define defaults
instance.defaults.headers.common['Content-Type'] = 'application/json'
// instance.defaults.headers.get['Content-Type'] = 'application/json'
// instance.defaults.headers.post['Content-Type'] = 'application/json'
// instance.defaults.headers.put['Content-Type'] = 'application/json'
// instance.defaults.headers.patch['Content-Type'] = 'application/json'

export default instance